@Echo off
setlocal

:: Window Size
mode con:cols=81 lines=20


:: Current Version
set Ver1=v1.1


:: Header
set "TITLE_1=echo ---------------------------------------------------------------------------------"
set "TITLE_2=echo --------------------------- Easy 0GDTEX.PVR Extractor ---------------------------"
set "TITLE_3=echo ------------------------------- Created By RazorX -------------------------------"
set "TITLE_4=echo ---------------------------------------------------------------------------------"


:: Grab Current Version From Offline
:::Offline
::if exist "..\Tools\E-Ver.txt" (
	::for /f "tokens=*" %%a in (..\Tools\E-Ver.txt) do set "Ver2=%%a"
	::goto ExtractorStart
::) else (
	::goto Online
::)


:: Grab Current Version From Online
:Online
powershell wget https://pastebin.com/raw/a6Kti3Yr -OutFile Tools\E-Ver.txt
for /f "tokens=*" %%a in (Tools\E-Ver.txt) do set "Ver2=%%a"
::del /s "..\Tools\E-Ver.txt" >nul 2>&1
goto ExtractorStart

:: Title
Title Easy 0GDTEX.PVR Extractor Created By RazorX %Ver1%


:: Store Game Directory And .GDI Name
:ExtractorStart
IF ("%~nx1") == ("") goto Exit
call set "folder=%~nx1"
for /f "Tokens=*" %%a in ('dir /b "%folder%\*.gdi"') do call set "GDI=%%a"
shift
goto ExtractorMenu


:: Check For Drag And Dropped Folder
:ExtractorMenu
CLS
if "%folder%"=="" (
	CLS
	%TITLE_1%
	%TITLE_2%
	%TITLE_3%
	%TITLE_4%
	echo:
	echo:
	echo Please Drag And Drop Game Folder On Bat File!
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	pause
	goto Exit
) else (
	goto BatVersion
)
goto ExtractorMenu


:: Check Bat Version Online
:BatVersion
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo This Version: %Ver1%
echo Current Version: %Ver2%
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto ExtractFiles


:: Extract IP.BIN And 0GDTEX.PVR
:ExtractFiles
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo:
echo Extracting Game Files Please Wait...
..\Tools\gditools.exe -i "%folder%\%GDI%" -o "%folder% Extracted" -e "0GDTEX.PVR" --silent >nul 2>&1
..\Tools\gditools.exe -i "%folder%\%GDI%" -o "%folder% Extracted\bootsector" -b "IP.BIN" --silent >nul 2>&1
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo:
echo Extracting Game ID And Region...
copy "%folder% Extracted\bootsector\IP.BIN" "..\Tools\TMP.BIN" >nul 2>&1
..\Tools\Dreamcast_Game_ID_Extractor.exe
for /f "tokens=*" %%i in (..\Tools\GAME_ID.txt) do set "id=%%i"
for /f "tokens=*" %%j in (..\Tools\REGION.txt) do set "reg=%%j"
if "%reg%"=="E" (
set "reg2=PAL"
)
if "%reg%"=="U" (
set "reg2=NTSC"
)
if "%reg%"=="UE" (
set "reg2=NTSC-PAL"
)
if "%reg%"=="J" (
set "reg2=JAP"
)
:: echo Game ID: "%id%"
:: echo Region: "%reg2%"
echo:
echo:
del /s "..\Tools\GAME_ID.txt" >nul 2>&1
del /s "..\Tools\REGION.txt" >nul 2>&1
del /s "..\Tools\TMP.BIN" >nul 2>&1
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto GameInfo


:: Confirm Game Info
:GameInfo
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Current Dir = "%CD%"
echo Game = "%folder%"
echo Region = "%reg2%"
echo GDI File = "%GDI%"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
set /P confirm=Is This Correct [Y/N]? 
if /I "%confirm%" EQU "Y" goto PVRSearch
if /I "%confirm%" EQU "N" goto GameInfoFailed
)
goto GameInfo


:: Game Info Incorrect
:GameInfoFailed
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo This Tool Was Unable To Get The Required Info
echo Please Try Again.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto Exit


:: Check If You Already Have The PVR File Named After The Game Folder
:PVRSearch
CLS
if exist "..\PVR_IMAGES\%folder%.PVR" (
	goto PVRFound
) else (
	goto PVRSearch2
)
goto PVRSearch


:: Check If You Already Have The PVR File Named After The Game ID And Region
:PVRSearch2
CLS
if exist "..\PVR_IMAGES\%id% (%reg2%).PVR" (
	goto PVRFound
) else (
	goto PVRCheck
)
goto PVRSearch2


:: The PVR Was Found In Your Collection
:PVRFound
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo Detected The PVR In The PVR_IMAGES Folder
echo There Is No Need To Continue.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto DeleteExtracted1


:: Check If The Extracted Game Contains A 0GDTEX.PVR
:PVRCheck
CLS
if exist "%folder% Extracted\0GDTEX.PVR" (
	goto PVRFound2
) else (
	goto NoPVR
)
goto PVRCheck


:: The Extracted Game Doesn't Contain A 0GDTEX.PVR
:NoPVR
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo I'm Sorry This Game Doesn't Contain A PVR File.
echo Folder: "%folder%" : Game ID And Region: %id% (%reg2%)>>"..\No Default PVR Log.txt"
echo:
echo "%folder%" Added To 'No Default PVR Log.txt'
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto DeleteExtracted1


:: Detected The 0GDTEX.PVR In The Extracted Folder Notification
:PVRFound2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo Detected 0GDTEX.PVR, Copying It Now...
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto PVRSaved


:: Choose What You Want To Save The PVR Name As
:PVRName
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo What Would You Like To Call The PVR File?
echo:
echo:
echo 1. "%id% (%reg2%).PVR"
echo 2. "%folder%.PVR"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
set choice=
set /p choice=Please Enter 1 or 2: 
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='1' set "pvrname=%id% (%reg2%).PVR" & goto PVRSaved
if '%choice%'=='2' set "pvrname=%folder%.PVR" & goto PVRSaved
echo "%choice%" Is Not Valid, Try Again.
pause
goto PVRName


:: Adding The Extracted 0GDTEX.PVR To Your Collection Using The Name You Chose
:PVRSaved
set "pvrname=%folder%.PVR"
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
copy "%folder% Extracted\0GDTEX.PVR" "..\PVR_IMAGES\%pvrname%" >nul 2>&1
echo The PVR Has Been Renamed Too: "%pvrname%"
echo And Added To Your Collection, Enjoy.
echo Folder: "%folder%" : Game ID And Region: %id% (%reg2%)>>"..\My PVR Dumps.txt"
echo PVR Added To 'My PVR Dumps.txt'
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto DeleteExtracted1


:: Delete The Extracted Game's Folder And Goto Extract PNG
:DeleteExtracted1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Deleting The Extracted Folder Now!
echo "%folder% Extracted"
echo Folder Deleted.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
rmdir "%folder% Extracted" /s /q
goto PNG1


:: Delete The Extracted Game's Folder And Directs You To The Delete Game Option
:DeleteExtracted2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Deleting The Extracted Folder Now!
echo "%folder% Extracted"
echo Folder Deleted.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
rmdir "%folder% Extracted" /s /q
goto DeleteGame1


:: Chose If You Want To Delete The Original Game Folder
:DeleteGame1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
set /P del=Would You Like To Delete The Game Folder [Y/N]? 
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
if /I "%del%" EQU "Y" goto DeleteGame2
if /I "%del%" EQU "N" goto PNG1


:: Deleting The Original Game Folder
:DeleteGame2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Deleting The Game Folder Now!
echo "%folder%"
echo Folder Deleted.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
rmdir "%folder%" /s /q
goto PNG1


:: Extract PNG From PVR
:PNG1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo:
IF ("%~nx1") == ("") (
	echo Extracting PNG Files Please Wait...
	..\Tools\pvr2png.exe "..\PVR_IMAGES" "..\PVR_IMAGES" >nul 2>&1
)
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto PNG2


:: PNG Extracted Message
:PNG2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo:
if ("%~nx1") == ("") (
	echo PNG Files Successfully Extracted.
)
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto ExtractorStart


:: Exit Extractor Script
:Exit
exit