@Echo off

:: Window Size
mode con:cols=81 lines=20


:: Current Version
Set Ver1=v1.9b


:: Header
Set "TITLE_1=echo ---------------------------------------------------------------------------------"
Set "TITLE_2=echo ------------------------------ Easy 0GDTEX.PVR Tool -----------------------------"
Set "TITLE_3=echo ------------------------------- Created By RazorX -------------------------------"
Set "TITLE_4=echo ---------------------------------------------------------------------------------"


:: Grab Current Version From Online
:Online
powershell wget https://pastebin.com/raw/6FBp3nQs -OutFile ..\Tools\T-Ver.txt
For /f "tokens=*" %%a IN (..\Tools\T-Ver.txt) Do Set "Ver2=%%a"
goto ToolStart


:: Title
Title Easy 0GDTEX.PVR Tool Created By RazorX %Ver1%


:: Store Game Directory And .GDI Name
:ToolStart
Set "folder=%~nx1"
If Exist "%folder%\name.txt" (
	SETLOCAL DisableDelayedExpansion
	FOR /F "usebackq delims=" %%a IN (`"findstr /n ^^ %folder%\name.txt"`) do Set "gdemu=%%a"
	SETLOCAL EnableDelayedExpansion
	ENDLOCAL
	for /f "Tokens=*" %%a IN ('dir /b "%folder%\*.gdi"') do Set "GDI=%%a"
	shift
	goto ToolMenu
) else (
	for /f "Tokens=*" %%a IN ('dir /b "%folder%\*.gdi"') do Set "GDI=%%a"
	shift
	goto ToolMenu
)


:: Check For Drag And Dropped Folder
:ToolMenu
CLS
If "%folder%"=="" (
	CLS
	%TITLE_1%
	%TITLE_2%
	%TITLE_3%
	%TITLE_4%
	echo:
	echo:
	echo Please Drag And Drop Game Folder On Bat File!
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	pause
	goto Exit
) else (
	goto ExtractFiles
)
goto ToolMenu


:: Extract IP.BIN And 0GDTEX.PVR
:ExtractFiles
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
If Exist "Bootsector" (
rmdir "Bootsector" /s /q >nul 2>&1
)
If Exist "%gdemu:~2%" (
	FOR /F "delims=" %%I IN ('DIR /B /A:D /S *%gdemu:~2%*') Do Set "NAME=%%I"
	FOR /D %%D IN ("%NAME%") Do Set "NAME=%%~dpD"
	Set "NAME=%NAME:~0,-1%"
	Set TMP=%NAME%
	FOR %%G IN ("%TMP%") Do Set TMP=%%~nxG
	Set Title=%TMP%
	If Exist "%Title%" (
		rmdir "%Title%" /s /q >nul 2>&1
	)
)
echo:
echo:
echo Extracting Game Files Please Wait...
..\Tools\gditools.exe -i "%folder%\%GDI%" --data-folder __volume_label__ -b "..\Bootsector\IP.BIN" --extract-all --silent >nul 2>&1
For /d %%I IN ("%folder%\*") Do Set "DIR=%%~nxI" >nul 2>&1
For /d %%a IN ("%folder%\*") Do Move /y "%%~fa" %2 >nul 2>&1
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo:
echo Extraction Complete.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo:
echo Extracting Game ID And Region...
copy "..\GDI_GAMES\Bootsector\IP.BIN" "..\Tools\TMP.BIN" >nul 2>&1
..\Tools\Dreamcast_Game_ID_Extractor.exe
For /f "tokens=*" %%i IN (..\Tools\GAME_ID.txt) Do Set "id=%%i"
For /f "tokens=*" %%j IN (..\Tools\REGION.txt) Do Set "reg=%%j"
If "%reg%"=="J" (
Set "reg2=JAP"
)
If "%reg%"=="U" (
Set "reg2=NTSC"
)
If "%reg%"=="E" (
Set "reg2=PAL"
)
If "%reg%"=="JU" (
Set "reg2=JAP-NTSC"
)
If "%reg%"=="JUE" (
Set "reg2=JAP-NTSC-PAL"
)
If "%reg%"=="UE" (
Set "reg2=NTSC-PAL"
)
echo Game ID: "%id%"
echo Region: "%reg2%"

If Exist "..\Tools\GAME_ID.txt" (
del /s "..\Tools\GAME_ID.txt" >nul 2>&1
)
If Exist "..\Tools\REGION.txt" (
del /s "..\Tools\REGION.txt" >nul 2>&1
)
If Exist "..\Tools\BIN.txt" (
del /s "..\Tools\BIN.txt" >nul 2>&1
)
If Exist "..\Tools\TMP.BIN" (
del /s "..\Tools\TMP.BIN" >nul 2>&1
)
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto GameInfo


:: Confirm Game Info
:GameInfo
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Current Dir = "%CD%"
echo Game = "%folder%"
echo Region = "%reg2%"
echo GDI File = "%GDI%"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /P confirm=Is This Correct [Y/N]? 
If /I "%confirm%" EQU "Y" goto PVRSearch
If /I "%confirm%" EQU "N" goto GameInfoFailed
goto GameInfo


:: Game Info Incorrect
:GameInfoFailed
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo:
echo:
echo This Tool Was Unable To Get The Required Info, Please Try Again.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
pause
goto DeleteExtracted1


:: Check If You Already Have The PVR File Named After The Game Folder
:PVRSearch
CLS
If Exist "..\PVR_IMAGES\%folder%.PVR" (
	goto PVRFound
) else (
	goto PVRSearch2
)
goto PVRSearch


:: Check If You Already Have The PVR File Named After The Game ID And Region
:PVRSearch2
If Exist "..\PVR_IMAGES\%id% (%reg2%).PVR" (
	goto PVRFound2
) else (
	goto NoPVR
)
goto PVRSearch2


:: The Extracted Game Doesn't Contain A 0GDTEX.PVR
:NoPVR
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo I'm Sorry No PVR Was Detected, Please Check You Have The PVR IN The
echo PVR_IMAGES Folder And Enter The Name Below.
echo:
echo:
If Exist "%folder%\name.txt" (
	echo Title From GDEMU name.txt:
	echo %gdemu:~2%
) else (
	echo:
	echo:
)
echo:
echo:
echo:
echo:
echo:
echo:
Set /P PVRManualName=Enter PVR Name (Without Extension): 
goto NoPVRCheckName


:: Check Manually Entered PVR Name
:NoPVRCheckName
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Is This Correct?
echo:
echo:
echo Name = "%PVRManualName%.PVR"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /P art=Would You Like To Use It [Y/N]? 
If /I "%art%" EQU "Y" goto NoPVRCheckExists
If /I "%art%" EQU "N" goto NoPVR
goto NoPVRCheckName


:: Check If 
:NoPVRCheckExists
CLS
If Exist "..\PVR_IMAGES\%PVRManualName%.PVR" (
	goto NoPVRCheckNameCopy
) else (
	goto DeleteExtractedConfirmation2
)
goto NoPVRCheckExists


:: Copy Manually Entered PVR Over
:NoPVRCheckNameCopy
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
::echo Detected 0GDTEX.PVR, Deleting It Now!
If Exist "..\GDI_GAMES\%DIR%\0GDTEX.PVR" (
del /s "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
)
echo Copying 0GDTEX.PVR From PVR_IMAGES To Extracted GDI
echo Name = "%PVRManualName%.PVR"
copy "..\PVR_IMAGES\%PVRManualName%.PVR" "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
echo File Copied.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto DetectGDIType


:: Option To Use The PVR Was Found IN Your Collection Named After Game Folder
:PVRFound
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Detected The PVR IN The PVR_IMAGES Folder!
echo:
echo:
echo Name = "%folder%.PVR"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /P art=Would You Like To Use It [Y/N]? 
If /I "%art%" EQU "Y" goto PVRCheck1
If /I "%art%" EQU "N" goto DeleteExtractedConfirmation2
goto PVRFound


:: Option To Use The PVR Was Found IN Your Collection Named After Game ID And Region
:PVRFound2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Detected The PVR IN The PVR_IMAGES Folder!
echo:
echo:
echo Name = "%id% (%reg2%).PVR"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /P art=Would You Like To Use It [Y/N]? 
If /I "%art%" EQU "Y" goto PVRCheck2
If /I "%art%" EQU "N" goto DeleteExtractedConfirmation2
goto PVRFound2


:: Check If The Extracted Game Contains A 0GDTEX.PVR
:PVRCheck1
CLS
If Exist "%folder% Extracted\0GDTEX.PVR" (
	goto ReplacePVR1
) else (
	goto CopyPVR1
)
goto PVRCheck1


:: Check If The Extracted Game Contains A 0GDTEX.PVR
:PVRCheck2
CLS
If Exist "%folder% Extracted\0GDTEX.PVR" (
	goto ReplacePVR2
) else (
	goto CopyPVR2
)
goto PVRCheck2


:: Copying Over Replacement 0GDTEX.PVR That's Named After The Game Folder
:CopyPVR1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Copying 0GDTEX.PVR From PVR_IMAGES To Extracted GDI
echo Name = "%folder%.PVR"
copy "..\PVR_IMAGES\%folder%.PVR" "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
echo File Copied.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto DetectGDIType


:: Copying Over Replacement 0GDTEX.PVR That's Named After The Game ID And Region
:CopyPVR2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Copying 0GDTEX.PVR From PVR_IMAGES To Extracted GDI
echo Name = "%id% (%reg2%).PVR"
copy "..\PVR_IMAGES\%id% (%reg2%).PVR" "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
echo File Copied.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto DetectGDIType


:: Deleting Game's Existing 0GDTEX.PVR File And Copying Over Replacement That's Named After The Game Folder
:ReplacePVR1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
::echo Detected 0GDTEX.PVR, Deleting It Now!
If Exist "..\GDI_GAMES\%DIR%\0GDTEX.PVR" (
del /s "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
)
::echo File Deleted.
echo Copying 0GDTEX.PVR From PVR_IMAGES To Extracted GDI
echo Name = "%folder%.PVR"
copy "..\PVR_IMAGES\%folder%.PVR" "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
echo File Copied.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto DetectGDIType


:: Deleting Game's Existing 0GDTEX.PVR File And Copying Over Replacement That's Named After The Game ID And Region
:ReplacePVR2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
::echo Detected 0GDTEX.PVR, Deleting It Now!
If Exist "..\GDI_GAMES\%DIR%\0GDTEX.PVR" (
del /s "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
)
::echo File Deleted.
echo Copying 0GDTEX.PVR From PVR_IMAGES To Extracted GDI
echo Name = "%id% (%reg2%).PVR"
copy "..\PVR_IMAGES\%id% (%reg2%).PVR" "..\GDI_GAMES\%DIR%\0GDTEX.PVR" >nul 2>&1
echo File Copied.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
goto DetectGDIType


:: Detecting GDI Type, CDDA or No CDDA
:DetectGDIType
CLS
cd "..\GDI_GAMES\%folder%"
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Please Wait...
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
For /f "Tokens=*" %%a IN ('dir /b "*.gdi"') Do Set "GDI=%%a"
If Exist "%CD%\Track04.raw" (
	CLS
	%TITLE_1%
	%TITLE_2%
	%TITLE_3%
	%TITLE_4%
	echo:
	echo:
	echo Please Wait...
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	For /f "Tokens=*" %%a IN ('dir /b "Track*.raw" ^| find "Track*.raw" /v /n /c') Do Set "RAWTotal=%%a"
	Set /a RAWCount=3
	Set /a Count2Total=1
	goto BuildGDIType1
) else (
	Goto BuildGDIType2
)


:: Rebuilding GDI For CDDA Game
:BuildGDIType1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Please Wait...
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /a Count2Total+=1
Set /a RAWCount+=1
If %RAWCount% LSS 10 Set "TRACK0%RAWCount%=TRACK0%RAWCount%.raw"
If %RAWCount% GTR 9 Set "TRACK%RAWCount%=TRACK%RAWCount%.raw"
If Not "%RAWTotal%"=="%Count2Total%" Goto BuildGDIType1
Set /a RAWCount-=3
CLS
cd "..\GDI_GAMES\%folder%"
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Please Wait...
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Current Dir = "%CD%"
echo Game = "%folder%"
echo Region = "%reg2%"
echo GDI File = "%GDI%"
echo Total CDDA Tracks = "%RAWCount%"
echo:
echo Building New Image Please Wait...
echo:
echo:
echo:
..\..\Tools\buildgdi.exe -data "..\%DIR%" -ip "..\Bootsector\IP.BIN" -output "" -gdi "%GDI%" -raw -V "%DIR%" -cdda %TRACK04% %TRACK05% %TRACK06% %TRACK07% %TRACK08% %TRACK09% %TRACK10% %TRACK11% %TRACK12% %TRACK13% %TRACK14% %TRACK15% %TRACK16% %TRACK17% %TRACK18% %TRACK19% %TRACK20% %TRACK21% %TRACK22% %TRACK23% %TRACK24% %TRACK25% %TRACK26% %TRACK27% %TRACK28% %TRACK29% %TRACK30% %TRACK31% %TRACK32% %TRACK33% %TRACK34% %TRACK35% %TRACK36% %TRACK37% %TRACK38% %TRACK39% %TRACK40% %TRACK41% %TRACK42% %TRACK43% %TRACK44% %TRACK45% %TRACK46% %TRACK47% %TRACK48% %TRACK49% %TRACK50% %TRACK51% %TRACK52% %TRACK53% %TRACK54% %TRACK55% %TRACK56% %TRACK57% %TRACK58% %TRACK59% %TRACK60% %TRACK61% %TRACK62% %TRACK63% %TRACK64% %TRACK65% %TRACK66% %TRACK67% %TRACK68% %TRACK69% %TRACK70% %TRACK71% %TRACK72% %TRACK73% %TRACK74% %TRACK75% %TRACK76% %TRACK77% %TRACK78% %TRACK79% %TRACK80% %TRACK81% %TRACK82% %TRACK83% %TRACK84% %TRACK85% %TRACK86% %TRACK87% %TRACK88% %TRACK89% %TRACK90% %TRACK91% %TRACK92% %TRACK93% %TRACK94% %TRACK95% %TRACK96% %TRACK97% %TRACK98% %TRACK99% %TRACK100% >nul 2>&1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Current Dir = "%CD%"
echo Game = "%folder%"
echo Region = "%reg2%"
echo GDI File = "%GDI%"
echo Total CDDA Tracks = "%RAWCount%"
echo:
echo Image Creation Complete.
echo:
echo:
echo:
echo:
echo:
pause
goto DeleteExtracted1


:: Rebuilding GDI For No CDDA Game
:BuildGDIType2
CLS
cd "..\GDI_GAMES\%folder%"
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Current Dir = "%CD%"
echo Game = "%folder%"
echo Region = "%reg2%"
echo GDI File = "%GDI%"
echo No CDDA Tracks
echo:
echo Building New Image Please Wait...
echo:
echo:
echo:
..\..\tools\buildgdi.exe -data "..\%DIR%" -ip "..\Bootsector\IP.BIN" -output "" -gdi "%GDI%" -raw -V "%DIR%" >nul 2>&1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo Current Dir = "%CD%"
echo Game = "%folder%"
echo Region = "%reg2%"
echo GDI File = "%GDI%"
echo No CDDA Tracks
echo:
echo Image Creation Complete.
echo:
echo:
echo:
echo:
echo:
pause
goto DeleteExtracted1


:: Asking For You To Confirm If You Want To Delete The Extracted Folder
:DeleteExtractedConfirmation1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Extracted Folders:
echo "%DIR%"
echo "Bootsector"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /P dl1=Would You Like To Delete The Extracted Folders [Y/N]? 
If /I "%dl1%" EQU "Y" goto DeleteExtracted1
If /I "%dl1%" EQU "N" goto PNGCHECK
goto DeleteExtractedConfirmation1


:: Asking For You To Confirm If You Want To Delete The Extracted Folder
:DeleteExtractedConfirmation2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Extracted Folders:
echo "%DIR%"
echo "Bootsector"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
Set /P dl2=Would You Like To Delete The Extracted Folders [Y/N]? 
If /I "%dl2%" EQU "Y" goto DeleteExtracted2
If /I "%dl2%" EQU "N" goto PNGCHECK
goto DeleteExtractedConfirmation2


:: Deleting The Extracted Game's Folder
:DeleteExtracted1
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Deleting The Extracted Folder Now!
echo "%DIR%"
echo "Bootsector"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
If Exist "..\%DIR%" (
rmdir "..\%DIR%" /s /q >nul 2>&1
)
If Exist "..\Bootsector" (
rmdir "..\Bootsector" /s /q >nul 2>&1
)
cd "..\"
goto FolderDeletedMessage


:: Deleting The Extracted Game's Folder
:DeleteExtracted2
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Deleting The Extracted Folder Now!
echo "%DIR%"
echo "Bootsector"
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
If Exist "..\%DIR%" (
rmdir "..\%DIR%" /s /q >nul 2>&1
)
If Exist "..\Bootsector" (
rmdir "..\Bootsector" /s /q >nul 2>&1
)
cd "..\"
goto FolderDeletedMessage


:: Message Confirming Folder Was Deleted
:FolderDeletedMessage
CLS
%TITLE_1%
%TITLE_2%
%TITLE_3%
%TITLE_4%
echo:
echo:
echo Extracted Folder Deleted.
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
echo:
::pause
goto PNGCHECK


::Check PNG Exists
:PNGCHECK
CLS
If Not "%PVRManualName%"=="" Set "PNGName=%PVRManualName%"
If Not "%folder%"=="" Set "PNGName=%folder%"
goto PNG1


:: Extracting The Disc Image From The 0GDTEX.PVR's
:PNG1
CLS
If Exist "..\PVR_IMAGES\%PNGName%.png" (
	goto Exit
) else (
	%TITLE_1%
	%TITLE_2%
	%TITLE_3%
	%TITLE_4%
	echo:
	echo:
	echo:
	echo:
	echo:
	echo Extracting PNG Files Please Wait...
	..\Tools\Pvr2Png.exe "..\PVR_IMAGES\%PNGName%.PVR" "..\PVR_IMAGES\%PNGName%.png" >nul 2>&1
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	echo:
	goto Exit
)
goto Exit

:: Success Message From Extracting The Disc Image From The 0GDTEX.PVR's
:::PNG2
::CLS
::%TITLE_1%
::%TITLE_2%
::%TITLE_3%
::%TITLE_4%
::echo:
::echo:
::echo:
::echo:
::echo:
::echo PNG Files Successfully Extracted.
::echo:
::echo:
::echo:
::echo:
::echo:
::echo:
::echo:
::echo:
::echo:
::pause
::goto Exit


:: Exit Extractor Script
:Exit
If "%~nx1"=="" Exit (
) else (
	goto ToolStart
)